# Ganymede: an 8-track, semi-automatic samples-looper and percussion instrument based on modulus instead of metro

## Background:

Ganymede was created to test a bet I made with myself: 

*that I could boil down drum sequencing to a single knob (i.e. instead of writing a pattern).* 

As far as I am concerned, I won the bet.

The trick is...

Instead of using a knob to turn, for example, up or down a metro, you use it to turn up or down the modulus of a counter, ie. counter[1..16]>[mod X]>[sel 0]>play the sample. If you do this then add an offset control, where the beat occurs changes in Real-Time.

But you'll have to decide for yourself whether I won the bet. :-). 

(note: I have posted a few demos using it in various stages of its' carnation recently in the Output section of the Forum and intend to share a few more now that I have posted this.)

Remember, Ganymede is an instrument, i.e. Not an editor. 

It is intended to be "played" or...allowed to play by itself.

(aside: specifically designed to be played with an 8-channel, usb, midi, mixer controller and mouse, for instance an Akai Midimix or Novation LaunchPad XL.)

So it does Not save patterns nor do you "write" patterns.

Instead, you can *play* it and save the audio~ output to a wave file (for use later as a loop, song, etc.)


Jumping straight to The Chase...

## How to use it:

REQUIRES:
moonlib, zexy, list-abs, hcs, cyclone, tof, freeverb~ and iemlib

![readme](Screenshot.jpg)

### THE 7 SECTIONS:

* **GLOBAL:**
	* to set parameters for all 8 tracks, exs. pick the samples directory from a tof/pmenu or OPEN\_IND\_DIR (open an independent directory) (see below "Samples"for more detail)
	* randomizing parameters, random all. randomize all every 10*seconds, maximum number of bars when randomizing bars, CLR the randomizer check boxes
	* PLAY, L(imited) or I(nfinite) counter, if L then number of bars to play before resetting counter, bpm(menu)
	* MSTVOL
	* transport/recording (on REC files are automatically saved to ./ganymede/recordings with datestamp filename, the output is zexy limited to 98 and the volume controls the boost into the limiter)

* **PLAYHEADS:**  
	* indicating where the track is "beating"
	* blank=no beat and black-to-red where redder implies greater env~ rms

* **MODULAE:**  
	* for information only to show the relative values of the selected modulators

* **WEIGHTS:**  
	* sent to [list-wrandom] when randomizing the When, Accent, and Offset modulators
	* to use click READ_ARRAYS, adjust as desired, click WRITE, uncheck READ ARRAYS
	* EVEN=unweighted, RND for random, and 0-7 for preset shapes

* **PRESETS:**  
	* ...self explanatory

* **PER TRACK ACCORDION:**  
	* 8 sections, 1 per track
	* each open-closable with the left most bang/track
	* opening one track closes the previously opened track
	* includes main (always shown)
		* with knobs for the sample (with 300ms debounce)
		* knobs for the modulators (When, Accent, and Offset) [1..16]
		* toggles if you want that parameter to be randomized after X bars
	* and when opened, 5 optional effects
		* adsr, vcf, delayfb, distortion, and reverb
		* D-W=dry-wet
		* 2 parameters per effect

* **ALL:**
when ON. sets the values for all of the tracks to the same value; reverts to the original values when turned OFF


### MIDI:

CC 7=MASTER VOLUME

The other controls exposed to midi are the first four knobs of the accordion/main-gui. In other words, the Sample, When, Accent, and Offset knobs of each track. And the MUTE and SOLO of each track.

Control is based on a midimap file (./midimaps/midimap-default.txt).

So if it is easier to just edit that file to your controller, then just make a backup of it and edit as you need. In other words, midi-learn and changing midimap files is not supported.

The default midimap is:

By track

#### CCs

| TRACK | SAMPLE | WHEN | ACCENT | OFFSET|
| :------------- |:-------------:|:-------------:|:-------------:|:-------------:|
|0|16|17|18|19|
|1|20|21|22|23|
|2|24|25|26|27|
|3|28|29|30|31|
|4|46|47|48|49|
|5|50|51|52|53|
|6|54|55|56|57|
|7|58|59|60|61|

#### NOTEs

| TRACK | MUTE |SOLO|
| :------------- |-------------:|-------------:|
|0|1|3|
|1|4|6|
|2|7|9|
|3|10|12|
|4|13|15|
|5|16|18|
|6|19|21|
|7|22|24|


### SAMPLES:


Ganymede looks for samples in its ./samples directory by subdirectory.

It generates a menu tof/pmenu from the directories in ./samples.

Once a directory is selected, it then searches for ./\*\*/*.wav (wavs within 1-deep subdirectories) and then ./**.wav (wavs within that main "kit" directory).

I have uploaded my collection of samples (that I gathered from https://archive.org/details/old-school-sample-cds-collection-01) to the following link on my Google Drive: 

https://drive.google.com/file/d/1SQmrLqhACOXXSmaEf0Iz-PiO7kTkYzO0/view?usp=sharing

It is a large 617 Mb .7z file, including two directories: by-instrument with 142 instruments and by-kit with 161 kits. The file names and directory structure have all been laid out according to Ganymede's needs, ex. no spaces, etc.

My suggestion to you is unpack the file into your Path so they are also available for all of your other patches.

### MAKING KITS:

I found Kits are best made by adding directories in a "custom-kits" folder and just adding files, but most especially shortcuts/symlinks to all the files or directories you want to include in the kit into that folder, ex. in a "bongs&congs"  folder add shortcuts to those instument folders. Then, create a symnlink to "bongs&congs" in your Ganymede/samples directory.

Note: if you want to experiment with kits on-the-fly (while the patch is on) just remember to click the REFRESH bang to get a new tof/pmenu of available kits in the ./samples directory.

If you want more freedom than a dynamic menu, you can use the OPEN\_IND(depedent)\_DIR bang to open any folder. But do bear in mind Ganymede may not see all the wavs in that folder.

- --

### AFTERWARD/NOTES

* the [hcs/folder_list] [tof/pmenu] can only hold (the first) 64 directories in the ./samples directory

* the use of 1/16th notes (counter-interval) is completely arbitrary. However, that value (in the [pd global_metro] subpatch...at the noted hradio) is exposed and I will probably incorporate being able to change it in a future version) 
* rem: one of the beauties of this technique is: If you don't like the beat,rhythm, etc., you need only (bang, ALL to get an entirely new beat or any of the other randomizers) to re-randomize it OR let if do that by itself on AUTO until you like it, then just take it off AUTO.
* One fun thing to do, is let if morph some set of toggles and bars selected and just keep an ear out for the Really choice ones. And it throws...rolls...a lot of them.
* Another thing to play around with is the notion of Limited (bumpy) or Infinite(flat) sequences in conjunction with the number of bars.
* Designed as I said before to be played, esp. once it gets rolling and you can focus on the production instead of the beats, meaning the ALL and individual effects.
* Note: if you really like the beat Don't forget to turn off the randomizers. CLEAR for instance works well. However you can't get the back after their cleared.
* The default.txt presets loads on loadbang. So if you want to save your state, then just click PRESETS>SAVE.
* [folder_list] throws error messages if it can't find things, ex. when your not using subdirectories in your kit. No need to worry about it. It just does that. :-)

---

### POSTSCRIPT

If you need any help, more explanation, advise, or have opinions or insight as to how I can make it better I would love to hear from you.

I think that's >=95% of it. If I think of anything else I'll add it below.

...I think that about covers it.

Peace thru Music.
Love thru PD.

-s
